#include <algorithm>
#include <fstream>
#include <valarray>
#include <iostream>
#include <algorithm>
#include <string>
#include <ranges>

#include "MeshLoader.h"
#include "AneuMeshLoader.h"
using namespace std;

int main() {
	MeshLoader* l = new AneuMeshLoader();   //!!! Отлично. Где delete? 
	try {
		l->loadMesh("a", ".aneu");
	}
	catch (std::exception& er) {
		std::cerr << er.what() << std::endl;
		delete l;
		return 0;
	}

	l->printNodes(l->getNodes());
	l->printFiniteElements(l->getFiniteElement());
	l->printFiniteElements(l->getBoundElement());

	std::cout << "ID Finite elements by nodes" << std::endl;
	auto finelem = l->getFiniteElementID(4,1,2);
	for (int elem : finelem) {
		std::cout << elem << " ";
	}
	std::cout << std::endl << "-----------------------------------" << std::endl;

	// Задание на защиту
	auto N = l->getNodes();
	auto n = l->getNodesByBorderID(3);
	Node N1(1, {2,2,2},0);
	l->SortedByDistance(n,N1);

	std::ofstream fout("out", std::ios::app);

	auto res1 = n | std::ranges::views::drop(10)
		| std::ranges::views::take(10);

	std::ranges::copy(res1, std::ostream_iterator<Node>(fout, "\n"));
	
	//!!! В задании написано - выводить координаты (!) вершин, а не Node.
	//!!! Где преобразование в pipeline из Node в std::array<double, dim> ?
	
	
	std::cout << n;
	std::cout << "-------------------------------------" << std::endl;
	
	delete l;
	
	return 0;
}